#!/usr/bin/perl -w

# Copyright (c) 2005 Michurin Alexey
# This program is free software; you
# can redistribute it and/or modify
# it under the terms of the GNU
# General Public License.
# This program is distributed in the
# hope that it will be useful, but
# WITHOUT ANY WARRANTY.

use strict;

my $MAX_DEPTH=10;

sub next_step {
    my ($x, $y, $dx, $dy, $d)=@_;
    my $x2=$x+$dx;
    my $y2=$y+$dy;
    if ($d++<$MAX_DEPTH) {
        my $dx2=$dx/2;
        my $dy2=$dy/2;
        next_step($x,  $y,
	          $dx2-$dy2,
		  $dy2+$dx2, $d);
        next_step($x2, $y2,
	         -$dx2-$dy2,
		 -$dy2+$dx2, $d);
    } else {
        print "$x $y m $x2 $y2 l\n";
    }
}

print <<'TEXT';
%!PS-Adobe-2.0 EPSF-2.0
%%BoundingBox: 0 0 388 260
/DeviceRGB setcolorspace
0 0 0 setcolor 1 setlinewidth
/m {moveto} bind def
/l {lineto} bind def
TEXT

next_step(88, 88, 256, 0, 0);

print "stroke showpage\n";

__END__

=pod

=head1 ,  

    
    .

=for html
<center><img src="examp.png" hspace="3"></center>

=for latex
\inspsfig{examp.eps}{.35}{  
(\texttt{\$MAX\_DEPTH=10}).}

=over

=item :

     .
      
 I< >.   ,
 ,   Σ, .

=back

=head2   

    .

=over

=item

 ,     
.    ,    ţ
   E<mdash>  , 
 I<>  ţ  ̣  .

=item

    , 
   .

=for html
<center><img src="two.png" hspace="3"></center>

=for latex
\inspsfig{two.eps}{.35}{ , ,
   ,  
.}

=item

   ,   
  ,  
      .

=item

""   .  
  ,   
 .    
,      
 .  
()  .

=back

=head1   

   EPS-  
.

=head2   

 ţ , , :

 $k.pl > drag.eps

 EPS- , , :

 gv drag.eps

 EPS-    
  C<gs>,  
   . :

 gs -sDEVICE=png16 \
    -sOutputFile=drag.png \
    -dBATCH \
    -dNOPAUSE \
    -r72x72 \
    -sPAPERSIZE=a5 \
    drag.eps

     C<gs(1)>.

=head2   

 ,     
  .

  ,    
      
 11.     
( ).   
 .

B< :>   
   ߣ  .
   EPS-.

=for html
<center><img src="steps.png"></center>

=for latex
\inspsfig{steps.eps}{.35}{ 
   ң 
.}

=head1  

   , 
.

=head2    

   
 .

  :

  1: #!/usr/bin/perl -w
  2: 
  3: # Copyright (c) 2005 Michurin Alexey
  4: # This program is free software; you
  5: # can redistribute it and/or modify
  6: # it under the terms of the GNU
  7: # General Public License.
  8: # This program is distributed in the
  9: # hope that it will be useful, but
 10: # WITHOUT ANY WARRANTY.
 11: 
 12: use strict;
 13: 
 14: my $MAX_DEPTH=10;
 15: 
 16: sub next_step {
 17:     my ($x, $y, $dx, $dy, $d)=@_;
 18:     my $x2=$x+$dx;
 19:     my $y2=$y+$dy;
 20:     if ($d++<$MAX_DEPTH) {
 21:         my $dx2=$dx/2;
 22:         my $dy2=$dy/2;
 23:         next_step($x,  $y,
 24: 	          $dx2-$dy2,
 25: 		  $dy2+$dx2, $d);
 26:         next_step($x2, $y2,
 27: 	         -$dx2-$dy2,
 28: 		 -$dy2+$dx2, $d);
 29:     } else {
 30:         print "$x $y m $x2 $y2 l\n";
 31:     }
 32: }
 33: 
 34: print <<'TEXT';
 35: %!PS-Adobe-2.0 EPSF-2.0
 36: %BoundingBox: 0 0 388 260
 37: /DeviceRGB setcolorspace
 38: 0 0 0 setcolor 1 setlinewidth
 39: /m {moveto} bind def
 40: /l {lineto} bind def
 41: TEXT
 42: 
 43: next_step(88, 88, 256, 0, 0);
 44: 
 45: print "stroke showpage\n";

 ,     34.
 34-41   EPS-. 
43  .  45 
  I<PostScript>.

ӣ  ģ  C<next_step>.
   :

=over

=item $x, $y

   E<mdash>   .

=item $dx, $dy

  ף E<mdash>  
.

=item $d

  .

=back

, C<next_step>  - 
.    , 
    ( 30).
  ,    
     ( 23  26),
  .

=over

=item 

    ,   ,
ף  45E<deg> ( ),
  ( ) 
   .

=item 

    , ף
 135E<deg>     .

=back

    .
    ,
  , 
  . ,   
.

=for html
<center><img src="steps.png"></center>

=for latex
\inspsfig{steps.eps}{.35}{
  ţ    .}

=head2    

  ,   .

=over

=item

     1.

=item

    .

=item

   .  
   01,    
 .     11
E<mdash> .

   :  
   C</010*$/> E<mdash>
,  C</110*$/> E<mdash> .

=item

     
,     (
 ).

=back

=head1 

  . 
     (,
 )    
.

 EPS-   ,
   ( ) 
 /
I<PostScript>-.

=head1 

     
  .

.

=head1 

  () 2005
